﻿#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QString>
#include <QList>
#include <QListView>
#include <QListWidgetItem>
#include <client.hpp>
#include <headers/ktextedit.hpp>
#include <argdialog.h>
#include <consoledialog.h>

namespace Ui {
class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit MainWindow(int argc = 0, char** argv = nullptr, QWidget* parent = nullptr);
    virtual void keyPressEvent(QKeyEvent* e);
    ~MainWindow();
private:
    Ui::MainWindow *ui;
    ArgDialog *arg_ui;
    void connectUi();
    void runApp();
    void updateProcessResult(int mask);
    QString parseMessage(const QString& s, StringVec v);
    int cli_argc;
    char** cli_argv;
    Client* q_client;
    QList<QString> m_events;
    ConsoleDialog m_console;

private slots:
    void connectClient();
    void updateMessages(int t, const QString& s, StringVec v);
    void handleInputEnterKey();
};


#endif // MAINWINDOW_H
